<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Arrays and Strings</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Arrays and Strings</h1>    
                    </section>
                    <section>
                        <h2>Arrays and Strings Overview</h2>
                        <ul>
                            <li>Style Guide</li>
                            <li>Stub Code</li>
                            <li>Arrays</li>
                            <li>Strings</li>
                            <li>String Methods</li>
                        </ul>
                    </section>
                    <section>
                        <h2>By the end of this lesson you should know:</h2>
                        <ul>
                            <li>Style for Arrays</li>
                            <li>How to declare, initialize, access and modify arrays & strings</li>
                        </ul>
                    </section>
                    <section><h2><a href=../objectives.html>Objectives</a></h2></section>
                </section>
                <!-- Coding Style Guide Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">   
                    <section>
                        <h2>Coding Style Guide</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Requirements</h2>
                        <ol>
                            <li>Comments</li>
                            <li>Meaningful Names</li>
                            <li>Indent/Brace Style</li>
                        </ol>
                    </section>
                    
                    <section>
                        <h2>Recommendations</h2>
                        <ol>
                            <li>Additional Comments</li>
                            <li>General Formatting Style (Pick a style and stick to it)</li>
                            <li>Variables (Initialize at declaration)</li>
                        </ol>
                    </section>

                </section>
                <!-- Arrays Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Arrays</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Array Facts</h2>
                        <ul>
                            <li>An array is a set of consecutive memory locations used to store data.</li>
                            <li>An item in an array is an <b>element</b></li>
                            <li>The number of elements in the array is called the <b>size</b> or <b>length</b></li>
                            <li>Arrays can have multiple <b>dimensions</b>.  Example: <code>var[x][y]</code> (dimension 2)</li>
                            <li>Arrays start at 0</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Declaring an Array</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
&ltdata type> &ltvariable name> [size];</span></code></pre>
                    </section>

                    <section>
                        <h2>Declaration Examples</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int courseNumbers [10];</span></code></pre>

                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
float testScores [7];</span></code></pre>

                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char firstName [15];</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing an Array</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
&ltdata type> &ltvariable name> [size] = {val1, val2, ...};</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing - Explicit Size</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int courseNumbers [8] = {101, 102, 103, 201, 202, 203, 301, 302};</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing - Implicit Size</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
float testScores [] = {72.1, 83.5, 92, 100, 99.9, 82, 70.5};</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing - Zeroize</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char availableGrades [4] = {0};</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing - Partial Zeroize</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char availableGrades [4] = {65, 66};</span></code></pre>
                    </section>

                    <section>
                        <h2>Initialization Review</h2>
                        <p>Fill in the blanks for the following arrays</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// first
int computerScienceCourses [] = {1003, 1023, 1033, 1063, 1073};

// second
float studentGPAs [7] = {2.7, 3.1, 2.9, 4, 3.9, 2.89, 3.55};

// third
char cardinalDirections [4] = {0};

// fourth
char catchPhrase [10] = {76, 101, 103, 101, 111};</code></pre></div></div>
                    </section>

                </section>

                <!-- Access & Modify Arrays Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Accessing & Modifying Arrays</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Accessing Array Elements</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
//syntax
&ltvariable name> [&ltindex>]
</span></code></pre>
                    </section>

                    <section>
                        <h2>Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int ages [5] = {25, 30, 19, 55, 92};

printf("Alice is: %d\n", ages[0])
//Prints Alice is: 25

printf("Bob is: %d\n", ages[1])
//Prints Bob is: 30

printf("Charles is: %d\n", ages[4])
//Prints Charles is: 92</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Modifying Array Elements</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int ages [5] = {25, 30, 19, 55, 92};

printf("Happy Birthday, Bob!\n");

ages[1]++; // Or ages[1] += 1
</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int one = 1; // A super-useful variable
char cardinalDirections [4] = {0}; // zeroize array
cardinalDirections [0] = 78;       // Sets index 0 to N
cardinalDirections [one] = 83;       // Sets index 1 to S because i = 1
cardinalDirections [one + one] = 'E';    // Sets index 2 to 69
cardinalDirections [one + 2] = 'W';    // Sets index 3 to 87
</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Demonstration Lab</h1>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Performance Lab</h1>
                </section>
                <!-- Strings Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Strings</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    
                    <section>
                        <h2>What is a String?</h2>
                        <ul>
                            <li>An array of chars, ending in a null character ('\n')</li>
                            <li>They are always one larger than string length, because of null terminator.</li>
                        </ul>
                    </section>

                    <section >
                        <h2>String Joke</h2>
                        <img src="../../assets/nullTerm.jpg" alt="Two strings walk into a bar. The first one says Hello! ;aw49 t$#( *1u Segmentation Fault" >   
                    </section>

                    <section>
                        <h2>Declaring Strings</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char &ltstring name> [size];</span></code></pre>
                    </section>

                    <section>
                        <h2>Declaration Examples</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char instructorName [10];</span></code></pre>

                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char inputBuffer [256];</span></code></pre>

                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char favorateWord [32];</span></code></pre>
                    </section>

                    <section>
                        <h2>Initializing a String</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char &ltvariable name> [size] = {char1, char2, '\0'};</span></code></pre>
                    </section>

                    <section>
                        <h2>Examples</h2>
                        <p>Fill in the blanks for the following arrays</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// Implicit
char instructorName [] = {'W', 'i', 'l', 'l', '\0'};

// Explicit
char greeting [3] = {'H', 'i', '\0'};

// Zeroize
char inputBuffer [256] = {0};

// Partial Zeroize
char studentLastName [32] = {89, 111, 117, 0};
</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Demonstration Lab</h1>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h1>Performance Lab</h1>
                </section>
                <!-- String Methods Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>String Methods</h1>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>More Readable String Declaration</h2>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
char name [] = "Will";</span></code></pre>
                    </section>

                    <section>
                        <h2>String.h</h2>
                        <p>These string functions are all defined in the header string.h</p>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
#include &ltstring.h>
                        </span></code></pre>
                    </section>

                    <section>
                        <h2>strcpy(string1, string2)</h2>
                        <p>Copies string2 into the variable string2</p>
                    </section>

                    <section>
                        <h2>strcat(string1, string2)</h2>
                        <p>Concatenates string2 to the end of string1 (make sure you have enough memory allocated)</p>
                    </section>

                    <section>
                        <h2>strlen(string1)</h2>
                        <p>Returns the length of string1</p>
                    </section>

                    <section>
                        <h2>strcmp(string1, string2)</h2>
                        <p>Compares the value of string1 and string2.</p>
                            <ul>
                                <li>Returns 0 if they are the same.</li>
                                <li>Reurns -1 if string1 <b>&lt</b> string2 </li>
                                <li>Reurns +1 if string1 <b>&gt</b> string2 </li>
                        </ul>
                    </section>

                    <section>
                        <h2>strcmpi(string1, string2)</h2>
                        <p>Same as strcmp, but case-insensitive</p>
                    </section>
                </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                            <ul>
                                <li>Style Guide</li>
                                <li>Stub Code</li>
                                <li>Arrays</li>
                                <li>Strings</li>
                                <li>String Methods</li>
                            </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
